/*
 * generated by Xtext
 */
package com.mylaensys.dsl.formatting

import org.eclipse.xtext.formatting.impl.AbstractDeclarativeFormatter
import org.eclipse.xtext.formatting.impl.FormattingConfig
import com.mylaensys.dsl.services.GapeGrammarAccess
import com.google.inject.Inject

/**
 * This class contains custom formatting description.
 * 
 * see : http://www.eclipse.org/Xtext/documentation.html#formatting
 * on how and when to use it 
 * 
 * Also see {@link org.eclipse.xtext.xtext.XtextFormattingTokenSerializer} as an example
 */
class GapeFormatter extends AbstractDeclarativeFormatter {

	@Inject extension GapeGrammarAccess grammar
	
	override protected void configureFormatting(FormattingConfig c) {
	// It's usually a good idea to activate the following three statements.
	// They will add and preserve newlines around comments
		val object = grammar.getObjectDeclarationAccess()
		
		c.setLinewrap().after(object.getLeftCurlyBracketKeyword_3())
		c.setLinewrap(2).after(object.getRightCurlyBracketKeyword_7())
		
		val module = grammar.getObjectDeclarationAccess()
		c.setIndentation(module.getLeftCurlyBracketKeyword_3(),module.getRightCurlyBracketKeyword_7())
		
		
		c.setLinewrap(0, 1, 2).before(SL_COMMENTRule)
		c.setLinewrap(0, 1, 2).before(ML_COMMENTRule)
		c.setLinewrap(0, 1, 1).after(ML_COMMENTRule)
		
	}
}
