package com.mylaensys.dsl.generator

import java.util.Set
import java.util.HashSet
import java.util.HashMap
import com.mylaensys.dsl.gape.ObjectDeclaration
import com.mylaensys.dsl.gape.PropertyDeclaration
import com.mylaensys.dsl.gape.MethodDeclaration

/**
 * Store the Object (types) declared in a module
 * 
 */
class SymbolTable {
	private HashMap<String,ObjectDeclaration> objects = new HashMap<String,ObjectDeclaration>()
	private HashMap<String,HashSet<MethodDeclaration>> interactionsInterfaces = new HashMap<String,HashSet<MethodDeclaration>>()
	 
	def HashMap<String,ObjectDeclaration> getObjects() {
		return this.objects
	}
	
	def HashMap<String,HashSet<MethodDeclaration>> getInteractionInterfaces() {
		return this.interactionsInterfaces
	}
	
	def PropertyDeclaration getProperty(String object,String property) {
		val ObjectDeclaration o = this.objects.get( object )
		for(p : o.properties) {
			if( p.name.equalsIgnoreCase( property ) ) {
				return p
			}
		}
		return null
	} 
	
	def Set<String> getSupportedTypes() {
		val Set<String> supportedTypes = new HashSet<String>()
		supportedTypes.add("java.lang.Short")
		supportedTypes.add("java.lang.Integer")
		supportedTypes.add("java.lang.Long")
		supportedTypes.add("java.lang.Float")
		supportedTypes.add("java.lang.Double")
		supportedTypes.add("java.lang.Boolean")
		supportedTypes.add("java.lang.String")
		supportedTypes.add("java.math.BigDecimal")		
		supportedTypes.add("java.util.Date")

		supportedTypes.add("com.google.appengine.api.datastore.Text")
		supportedTypes.add("com.google.appengine.api.datastore.Blob")
		

		return supportedTypes
	}
	
	
}