package com.mylaensys.dsl.generator.utils

import org.eclipse.emf.common.util.EList
import com.mylaensys.dsl.gape.Permission
import org.eclipse.xtext.common.types.TypesFactory

class Utils {
	/* See:https://developers.google.com/appengine/docs/java/datastore/jdo/dataclasses#Collections */
	def static isSupportedCollection(String collection) {
		if(collection.equalsIgnoreCase( "List" ) ) {
			return true;
		}		 
		if(collection.equalsIgnoreCase( "Set" ) ) {
			return true;
		}
		return false;				
	}
	/* Dump a Message */
	def static dump(String message,String value) {
		if( value != null ) {
			return message + ": " + value
		}
		return ""
	}
	/* Dump a permission */
	def static dumpPermissions(EList<Permission> permissions) {
		var String dump = ""
		for( p : permissions ) {
			dump = dump + p.name;
			dump = dump + ","
		}
		if( dump.length > 0 ) {
			dump = dump.substring(0,dump.length-1)	
		}		
		return '[' + dump + ']' 
	}
	/* Dump a constraint */	
	
	/* Creates a jvmType */	 
	def static createJvmType(String name,String targetPackage) {
	    val declaredType = TypesFactory::eINSTANCE.createJvmGenericType
	    declaredType.setSimpleName(name)
	    declaredType.setPackageName(targetPackage)
	    return declaredType
	}
	/* Creates a jvmType */	 
	def static createJvmType(String fullyQualifiedName) {
	    val declaredType = TypesFactory::eINSTANCE.createJvmGenericType
	    val name = fullyQualifiedName.substring(fullyQualifiedName.lastIndexOf(".")+1);
	    val targetPackage = fullyQualifiedName.substring(0,fullyQualifiedName.lastIndexOf("."));
	    declaredType.setSimpleName(name)
	    declaredType.setPackageName(targetPackage)
	    return declaredType
	}
		/* Create a plural word */
   	def  static makePlural(String singularWord){
        val  strippedWord = singularWord.substring(0, singularWord.length()-1);
        val char lastLetter = singularWord.charAt(singularWord.length()-1);
               
        if( lastLetter.compareTo('s') == 0 || 
        	lastLetter.compareTo('x') == 0 || 
        	lastLetter.compareTo('z') == 0) {
        	return singularWord + "es"
        }
        if( lastLetter.compareTo('h') == 0 ) {
        	if ((singularWord.charAt(singularWord.length()-2).compareTo('c') == 0) || 
        		(singularWord.charAt(singularWord.length()-2).compareTo('s') == 0)
        	) {
                    return  singularWord + "es"
			}
        }       
               
		if( lastLetter.compareTo('y') == 0 ) {
			if (isEnglishConsonant(singularWord.charAt(singularWord.length()-2))) {
                    return strippedWord + "ies"
			}
		}               
 
		return singularWord + "s"        
    }
    
    def static boolean isEnglishConsonant(char ch) {
    	val c = Character.toLowerCase(ch)
    	if( c.compareTo('a') == 0 || c.compareTo('e') == 0 || c.compareTo('i') == 0 || c.compareTo('o') == 0 || c.compareTo('u') == 0) {
    		return false
    	}
    	return true        
    }
    
    /* Check if a permission is granted */
	def static isPermissionGranted(EList<Permission> permissions, String required) {
		/* No permission is granted  */	
		if( permissions.empty ) 
			return true
		/* Check the permission */	
		for(p:permissions) {
			if( required.equalsIgnoreCase( p.name ))
				return true
		}		
		return false
	}
	 
}