/*
* generated by Xtext
*/
package com.mylaensys.dsl.ui.quickfix

import org.eclipse.emf.ecore.EObject
import org.eclipse.xtext.ui.editor.quickfix.Fix
import org.eclipse.xtext.ui.editor.quickfix.IssueResolutionAcceptor
import org.eclipse.xtext.validation.Issue
import com.mylaensys.dsl.validation.GapeValidator
import org.eclipse.xtext.diagnostics.Diagnostic
import org.eclipse.xtext.ui.editor.model.edit.IModificationContext
import org.eclipse.ui.internal.Model

import static extension org.eclipse.xtext.EcoreUtil2.*
import com.mylaensys.dsl.gape.ObjectDeclaration
import com.mylaensys.dsl.gape.ModuleDeclaration
import com.mylaensys.dsl.gape.GapeFactory

/**
 * Custom quickfixes.
 *
 * see http://www.eclipse.org/Xtext/documentation.html#quickfixes
 */
class GapeQuickfixProvider extends org.eclipse.xtext.ui.editor.quickfix.DefaultQuickfixProvider {

	@Fix(GapeValidator::INVALID_OBJECT_NAME)
	def capitalizeObjectName(Issue issue, IssueResolutionAcceptor acceptor) {
		acceptor.accept(issue, 'Capitalize Object name', 'Capitalize the name.', 'upcase.png') [
			context |
			val xtextDocument = context.xtextDocument
			val firstLetter = xtextDocument.get(issue.offset, 1)
			xtextDocument.replace(issue.offset, 1, firstLetter.toUpperCase)
		]
	}
	
	@Fix(GapeValidator::INVALID_PROPERTY_NAME)
	def lowercasePropertyName(Issue issue, IssueResolutionAcceptor acceptor) {
		acceptor.accept(issue, 'Lowercase property name', 'Lowercase property name.', 'lowcase.png') [
			context |
			val xtextDocument = context.xtextDocument
			val firstLetter = xtextDocument.get(issue.offset, 1)
			xtextDocument.replace(issue.offset, 1, firstLetter.toLowerCase)
		]
	}
	
	@Fix(GapeValidator::INVALID_INTERACTION_NAME)
	def capitalizeInteractionName(Issue issue, IssueResolutionAcceptor acceptor) {
		acceptor.accept(issue, 'Capitalize Interaction name', 'Capitalize the name.', 'upcase.png') [
			context |
			val xtextDocument = context.xtextDocument
			val firstLetter = xtextDocument.get(issue.offset, 1)
			xtextDocument.replace(issue.offset, 1, firstLetter.toUpperCase)
		]
	}
	
	@Fix(GapeValidator::INVALID_PROPERTY_NAME)
	def lowercaseMethodName(Issue issue, IssueResolutionAcceptor acceptor) {
		acceptor.accept(issue, 'Lowercase method name', 'Lowercase method name.', 'lowcase.png') [
			context |
			val xtextDocument = context.xtextDocument
			val firstLetter = xtextDocument.get(issue.offset, 1)
			xtextDocument.replace(issue.offset, 1, firstLetter.toLowerCase)
		]
	}
	
	@Fix(Diagnostic::LINKING_DIAGNOSTIC)
	def void createMissingObject(Issue issue, IssueResolutionAcceptor acceptor) {
		acceptor.accept(issue,
			"Create Object", // label
			"Create Object", // description
			"Entity.gif", // icon
			[ EObject element, IModificationContext context |
				val currentObject = element.getContainerOfType(typeof(ObjectDeclaration))
				val module = currentObject.eContainer as ModuleDeclaration
					module.objects.add(module.objects.indexOf(currentObject)+1, 
					GapeFactory::eINSTANCE.createObjectDeclaration() => [
						name = context.xtextDocument.get(issue.offset, issue.length)
					]
				)
			]
		);
	}	
}
